#!/usr/bin/env node
"use strict";function _interopDefault(e){return e&&"object"==typeof e&&"default"in e?e.default:e}function changes(){return transmute__default({}).extend("rawTags",gatherTags).extend("tags",parseTags).extend("latest",latestReleaseTag).extend("from",({latest:e})=>e.tag).extend("changes",gatherChanges)}function list(e){return transmute__default({}).extend("root",findRepoRoot).extend("rootStructure",getRootStructure).extend("rootManifest",getRootManifest).extend("exclude",["**/fixtures/**"]).extend("packageNames",filterPackages(e)).extend("structures",getStructures).extend("types",getTypes(e)).extend("manifests",getPackageDetails(e))}function dependencies(e){return list(e).extend("dependencies",getDependencies(e))}function build(e){const t=_extends({},e,filter$2(e));return list(t).extend("dependencies",dependencies(t).then(transmute.isolate("dependencies"))).extend("configs",buildRollupConfigs(e))}function check(e){return list(e).extend("checks",publishCheck(e))}function publish(e){return list(_extends({},e,{onlyPublishable:!0})).extend("destination",destinationDetails).extend("publishing",getPublishing)}function version(e){return list(_extends({},e,{changedAndPublishable:!0})).extend(changes(e).then(transmute.isolate(["changes","latest"]))).extend("dependencies",dependencies(e).then(transmute.isolate("dependencies"))).extend("updates",recommendVersions)}function prerelease(e){return check(e).extend("unpublishable",({packageNames:e,checks:t})=>e.filter(e=>!t.packages[e].publishable)).extend("name",({unpublishable:e})=>pickPackage({message:"Which package should we prerelease?",packageNames:e})).extend("structure",({name:e})=>getStructures({packageNames:[e]})[e]).extend("type",({name:t,structure:n})=>getTypes(e)({packageNames:[t],structures:{[t]:n}})[t]).extend(fixPackages(e))}var keyBy=_interopDefault(require("lodash.keyby")),every=_interopDefault(require("lodash.every")),chalk=require("chalk"),TS=_interopDefault(require("trie-search")),parse=_interopDefault(require("minimist")),RenderKid=_interopDefault(require("renderkid")),transmute=require("transmutation"),transmute__default=_interopDefault(transmute),toCamelCase=_interopDefault(require("to-camel-case")),prettyjson=require("prettyjson");require("loud-rejection/register");var path=require("path"),findUp=_interopDefault(require("find-up")),semver=require("semver"),fs=require("fs"),fs__default=_interopDefault(fs),unglob=_interopDefault(require("glob")),match=_interopDefault(require("minimatch")),promisify=_interopDefault(require("es6-promisify")),has=_interopDefault(require("lodash.has")),partial=_interopDefault(require("lodash.partial")),configureGit=_interopDefault(require("simple-git/promise")),uniq=_interopDefault(require("lodash.uniq")),detective=_interopDefault(require("detective-es6")),frontMatter=_interopDefault(require("front-matter")),fileExists=require("file-exists"),execa=_interopDefault(require("execa")),rimraf=_interopDefault(require("rimraf")),registryUrl=_interopDefault(require("registry-url")),localOrHomeNpmrc=_interopDefault(require("local-or-home-npmrc")),map=_interopDefault(require("lodash.map")),jsonFile=_interopDefault(require("jsonfile")),filter=_interopDefault(require("lodash.filter")),intersect=_interopDefault(require("lodash.intersection")),fuzzy=require("fuzzy"),inquirer=_interopDefault(require("inquirer")),autocomplete=_interopDefault(require("inquirer-autocomplete-prompt")),rollup=require("rollup"),pick=_interopDefault(require("lodash.pick")),uglifyEs=require("uglify-es"),babel=_interopDefault(require("rollup-plugin-babel")),uglify=_interopDefault(require("rollup-plugin-uglify")),filesize=_interopDefault(require("rollup-plugin-filesize")),markdown=_interopDefault(require("rollup-plugin-markdown")),nodeResolve=_interopDefault(require("rollup-plugin-node-resolve")),exec=_interopDefault(require("rollup-plugin-executable")),editor=_interopDefault(require("external-editor")),commonjs=_interopDefault(require("rollup-plugin-commonjs")),globals=_interopDefault(require("rollup-plugin-node-globals")),vuePlugin=_interopDefault(require("rollup-plugin-vue")),sanitizer=e=>{if(!Array.isArray(e))throw new Error("Commands must be an array");if(e.length<=0)throw new Error("No commands defined");if(!every(e,e=>"function"==typeof e.run))throw new Error("All commands must have a run method");if(!every(e,e=>"name"in e))throw new Error("Not every command has a name")},asyncToGenerator=function(e){return function(){var t=e.apply(this,arguments);return new Promise(function(e,n){function r(s,a){try{var i=t[s](a),o=i.value}catch(e){return void n(e)}if(!i.done)return Promise.resolve(o).then(function(e){r("next",e)},function(e){r("throw",e)});e(o)}return r("next")})}},_extends=Object.assign||function(e){for(var t=1;t<arguments.length;t++){var n=arguments[t];for(var r in n)Object.prototype.hasOwnProperty.call(n,r)&&(e[r]=n[r])}return e},toArray=function(e){return Array.isArray(e)?e:Array.from(e)},createSearcher=({commands:e=[]}={})=>{const t=e.map(e=>{const t=Array.isArray(e.aliases)?e.aliases:[e.aliases];return _extends({},e,{tokens:[e.name,...t].join(" ")})}),n=new TS(["tokens"]);return n.addAll(t),n},createDecider=({proposedDefault:e,commands:t})=>{const n=Object.values(t),r=1===n.length?n[0]:null,s=("string"==typeof e?t[e]:e)||r,a=createSearcher({commands:n});return e=>{if(!e)return s;const t=a.get(e);return t.length>0?t[0]:s||(console.log(chalk.red(`No command associated with \`${e}\``)),process.exit(127))}},convertArgs=({args:e={},conversions:t={}})=>Object.entries(e).map(([e,t])=>["_"!==e?toCamelCase(e):e,t]).map(([e,n])=>e in t?[t[e],n]:[e,n]).reduce((e,t)=>_extends({},e,{[t[0]]:t[1]}),{});const jsonRender=e=>t=>n=>e(prettyjson.render(transmute.isolate(t)(n))),cleanser=e=>t=>Object.entries(t).map(([t,n])=>t in e?{[t]:e[t](n)}:{[t]:n}).reduce((e,t)=>_extends({},e,t),{});var createExecutor=({config:e,cleanse:t,defaultRenderer:n,defaultStyle:r,decider:s}={})=>(a=[""])=>{const i=parse(a,{boolean:!0});var o=toArray(i._);const l=o[0],c=o.slice(1),u=i.commit,p=i.json,d=s(l),m=_extends({},i,{_:c}),f=convertArgs({args:m,conversions:d.args}),h=cleanser(t)(_extends({},e,f)),g=Promise.resolve(d.run(h)),b=d.renderer||n;if(p){const e=jsonRender(b);return g.then(e(!0===p||p.split(",")))}const y=new RenderKid;return y.style(r),g.then(e=>{b(d.template?y.render(d.template(e)):e),d.effect&&u&&d.effect(h)(e)})};const configureKli=({defaultStyle:e={},defaultRenderer:t=console.log}={})=>({default:n,config:r={},commands:s=[],cleanse:a={}}={})=>{sanitizer(s);const i=keyBy(s,"name"),o=createDecider({commands:i,proposedDefault:n});return{execute:createExecutor({config:r,defaultStyle:e,defaultRenderer:t,decider:o,cleanse:a})}},configure=configureKli,kli$1=configureKli();configureKli();var style={title:{display:"block",color:"bright-white",marginLeft:2,marginBottom:1},check:{display:"block",marginLeft:4},details:{color:"grey",marginLeft:4},success:{display:"block",color:"grey",bullet:`"${chalk.green("✔")} "`},fail:{display:"block",color:"red",bullet:`"${chalk.red("✖")} "`},list:{display:"block",marginTop:1},item:{display:"block",marginBottom:1},change:{display:"block"},type:{color:"white"},scope:{color:"bright-white"},subject:{color:"grey"},attr:{display:"block",marginLeft:2},key:{color:"grey",marginRight:1},value:{color:"white"},bar:{display:"block",color:"green",bullet:`"${chalk.green("────────────────────────────────────────────────────────────────────────────────")}"`},h1:{display:"block",color:"bright-white",marginLeft:2}},findRepoRoot=({anchor:e=".git"}={})=>findUp(e).then(path.dirname),template=({packageNames:e=[],manifests:t={}})=>`\n    <bar>-</bar>\n    <h1>Package List</h1>\n    <bar>-</bar>\n    <list>\n        ${e.map(e=>`<item>\n                <attr><key>Name:</key><value>${e}</value></attr>\n                <attr><key>Version:</key><value>${t[e].version||"No version"}</value></attr>\n            </item>`).join("")}\n    </list>\n    `,getRootManifest=({root:e="."}={})=>require(path.resolve(e,"package.json")),getPublishing=({destination:e={}}={})=>Object.entries(e).filter(([,{destVersion:e,srcVersion:t}])=>!!semver.valid(t)&&(!semver.valid(e)||semver.gt(t,e))).map(([e])=>e);const glob=promisify(unglob),lstat=promisify(fs__default.lstat),have=e=>t=>match(e,t);var findPackages=({root:e=".",exclude:t=[]}={})=>new Promise((()=>{var n=asyncToGenerator(function*(n,r){try{const s=path.resolve(e,"src/node_modules");if(!(yield lstat(s)).isDirectory)return r("The `src/node_modules` directory does not exist!");const a=path.resolve(s,"{[^@]*/,@*/*/}");return n((yield glob(a)).filter(function(e){return!t.some(have(e))}).map(function(t){return path.relative(path.resolve(e,"src/node_modules"),t)}))}catch(e){return r(e)}});return function(e,t){return n.apply(this,arguments)}})()),collapse=(e,t)=>{if(t.undefined){const n=e.undefined?[...e.undefined,t.undefined]:[t.undefined];return _extends({},e,{undefined:n})}return Object.assign(e,t)};const requiredProps=["description","homepage","author","repository","bugs","license","dependencies"],isIn=e=>partial(has,e);var publishCheck=({plugins:e={}}={})=>({rootStructure:{files:t=[]}={},rootManifest:n={},packageNames:r=[],types:s={},structures:a={},manifests:i={}}={})=>Promise.all(r.map(t=>{const n={[t]:{}};return e[s[t]]&&e[s[t]].check?e[s[t]].check({structure:a[t],manifest:i[t]}).then(e=>({[t]:e})):n})).then(e=>e.reduce(collapse,{})).then(e=>({root:{"has root license":t.includes("LICENSE"),"has required props":every(requiredProps,isIn(n))},packages:e}));const regex=/#(\d*)/;var parseTags=({rawTags:e=[]}={})=>e.map(e=>e.match(regex)||[]).filter(e=>e.length).map(([e,t])=>({tag:e,releaseNumber:parseInt(t,10)}));const git=configureGit();var gatherTags=()=>git.tags().then(({all:e})=>e),template$1=({changes:e})=>`\n    <bar>-</bar>\n    <h1>Changes</h1>\n    <bar>-</bar>\n    <list>\n        ${e.sort(()=>1).map(({type:e,scopes:t,subject:n})=>`\n                    <change>\n                        <type>${e}</type>\n                        <scope>(${t.join(",")})<scope>: \n                        <subject>${n}</subject>\n                    </change>\n                `).join("")}\n    </list>\n`;const regex$1=/^([^A-Z]*)\(((?:[^A-Z*]*)|\*)\): ([^a-z].*\.)$/,toHeaderOrBody=({body:e,matches:[,t,n,r]})=>t?{type:t,scopes:n.split(",").map(e=>e.trim()),subject:r}:{body:e},intoSingleCommits=(e,t)=>{if(0===e.length)return[t];var n=e.reverse(),r=toArray(n);const s=r[0],a=r.slice(1);return"body"in s&&"body"in t?[...a,_extends({},s,{body:[s.body,t.body].join("\n")})]:t.type?[...e,t]:[...a,_extends({},s,t)]},trimmedBodies=e=>e.body?_extends({},e,{body:e.body.trim()}):e;var parse$1=({commits:e=[]}={})=>Array.prototype.concat(...e.map(({hash:e,message:t,files:n})=>t.split(/\r?\n/).map(e=>({body:e,matches:e.match(regex$1)||[]})).map(toHeaderOrBody).reduce(intoSingleCommits,[]).map(trimmedBodies).map(t=>_extends({hash:e,files:n},t))));const git$1=configureGit();var gatherChanges=({from:e,to:t="HEAD"}={})=>git$1.log({from:e,to:t,format:{hash:"%H",message:"%B"}}).then(({all:e})=>Promise.all(e.map(e=>git$1.show(["--pretty=","--name-only",e.hash]).then(e=>e.trim().split("\n")).then(t=>_extends({},e,{files:t}))))).then(e=>({commits:e})).then(parse$1),latestReleaseTag=({tags:e=[]}={})=>e.filter(e=>e.releaseNumber).reduce((e,t)=>e.releaseNumber>t.releaseNumber?e:t,{tag:"HEAD",releaseNumber:0});const command$2=()=>({name:"changes",aliases:["changelog"],run:changes,template:template$1});var parse$2=({content:e=""}={})=>{var t=frontMatter(e);const n=t.attributes,r=t.body;return{body:r.trim(),attributes:n,code:r.split("\n").reduce(({inBlock:e,bundle:t},n)=>"```"===n.slice(0,3)?{inBlock:!e,bundle:t}:e?{inBlock:e,bundle:t?`${t}\n${n}`:n}:{inBlock:e,bundle:t},{inBlock:!1,bundle:""}).bundle}};const readFile=promisify(fs__default.readFile),cache={};var detective$1=({root:e,locals:t=[],structures:n={},manifests:r={}})=>(()=>{function s(e){return a.apply(this,arguments)}var a=asyncToGenerator(function*(a){if(!a)return{};var i=r[a]||{};const o=i.main,l=i.bin;var c=n[a]||{};const u=c.srcDir,p=c.files,d=o||(l?Object.values(l)[0]:p.includes("index.md")?"index.md":"index.js");return fileExists.sync(path.resolve(e,u,d))?readFile(path.resolve(e,u,d),"utf-8").then(function(e){return".md"===path.extname(d)?parse$2({content:e}).code:e}).then(detective).then(function(e){return Promise.all(e.map((()=>{var e=asyncToGenerator(function*(e){return t.includes(e)?e in cache?cache[e]:s(e).then(function(t){return 0===Object.keys(t).length&&t.constructor===Object?{[e]:!1}:{[e]:t}}).then(function(t){return cache[e]=t,t}):{[e]:!1}});return function(t){return e.apply(this,arguments)}})())).then(function(e){return e.reduce(collapse,{})})}):{}});return s})();const cache$1={},getStructure=({root:e,name:t})=>{if(t in cache$1)return{[t]:cache$1[t]};const n=path.relative(e,path.resolve(e,"src/node_modules",t)),r={name:t,root:e,srcDir:n,destDir:path.relative(e,path.resolve(e,"dist",t)),files:fs.readdirSync(path.resolve(e,n))};return cache$1[r.name]=r,{[t]:r}};var getStructures=({root:e,packageNames:t=[]})=>t.map(t=>getStructure({root:e,name:t})).reduce(collapse,{}),getPackageDetails=({plugins:e})=>({root:t=".",packageNames:n=[],types:r={},structures:s={}})=>Promise.all(n.map((()=>{var n=asyncToGenerator(function*(n){return"unknown"!==r[n]?{[n]:(yield e[r[n]].manifest({root:t,structure:s[n],name:n}))||{}}:{[n]:{}}});return function(e){return n.apply(this,arguments)}})())).then(e=>e.reduce(collapse,{})),getTypes=({plugins:e={}})=>({packageNames:t=[],structures:n={}})=>t.map(t=>[t,Object.values(e).find(({filter:e})=>e(n[t]))]).map(([e,{type:t="unknown"}={}])=>({[e]:t})).reduce(collapse,{}),getDependencies=e=>(()=>{var t=asyncToGenerator(function*({root:t,exclude:n,packageNames:r=[]}={}){if(!t)return{};if(r.length<=0)return{};var s=yield transmute__default({root:t,exclude:n}).extend("packageNames",findPackages).extend("structures",getStructures).extend("types",getTypes(e)).extend("manifests",getPackageDetails(e));const a=s.packageNames,i=s.structures,o=s.manifests,l=detective$1({root:t,locals:a,structures:i,manifests:o});return Promise.all(r.map(function(e){return l(e).then(function(e){return Object.entries(e).reduce(function e(t,[n,r]){return[...t,n,...Object.entries(r).reduce(e,[])]},[])}).then(uniq).then(function(t){return{[e]:{local:t.filter(function(e){return a.includes(e)}),external:t.filter(function(e){return!a.includes(e)})}}})})).then(function(e){return e.reduce(collapse,{})})});return function(){return t.apply(this,arguments)}})();const fields=["version"];var destinationDetails=({root:e,packageNames:t,structures:n})=>Promise.all(t.map(t=>Promise.all([execa("npm",["view",t,...fields]).then(e=>e.stdout).catch(()=>null),new Promise(r=>{try{const s=path.resolve(e,n[t].srcDir,"package.json");return r(require(s).version)}catch(e){throw e}}).catch(()=>null)]).then(([e,n])=>({[t]:{destVersion:e,srcVersion:n}})))).then(e=>e.reduce(collapse,{})),filterPackages=e=>t=>{const n=e.packageNames,r=e.allPackages,s=e.onlyPublishable,a=e.onlyChanged,i=e.changedAndPublishable,o=e.needsPublishing;if(r)return findPackages(t);if(Array.isArray(n)&&n.length>0)return n;if(!(o||i||s||a))return findPackages(t);const l=transmute__default(t).extend("packageNames",findPackages).extend("structures",getStructures).extend("types",getTypes(e)).extend("manifests",getPackageDetails(e));if(o)return l.extend("checks",publishCheck(e)).extend("publishable",({packageNames:e,checks:t})=>e.filter(e=>t.packages[e].publishable)).extend("destination",e=>destinationDetails(_extends({},e,{packages:e.publishable}))).extend("publishing",getPublishing).then(({publishing:e})=>e);if(s)return l.extend("checks",publishCheck(e)).then(({packageNames:e,checks:t})=>e.filter(e=>t.packages[e].publishable));const c=l.extend(changes).extend("dependencies",getDependencies(e)).extend("changed",({packageNames:e,dependencies:t,changes:n})=>e.filter(e=>n.some(({scopes:n=[]})=>n.includes(e)||n.some(n=>t[e].local.includes(n)))));return i?c.extend("checks",publishCheck(e)).then(({changed:e,checks:t})=>e.filter(e=>t.packages[e].publishable)):a?c.then(({changed:e})=>e):findPackages(t)},getRootStructure=({root:e})=>({files:fs.readdirSync(e)});const packageFilters={_:"packageNames",all:"allPackages",publishable:"onlyPublishable",changed:"onlyChanged",releasing:"changedAndPublishable",publishing:"needsPublishing"},command$1=()=>({name:"list",aliases:["ls"],run:list,template:template,args:packageFilters});var template$2=({packageNames:e,dependencies:t})=>`\n    <bar>-</bar>\n    <h1>Package Dependencies</h1>\n    <bar>-</bar>\n    <list>\n        ${e.map(e=>`<item>\n                <title>${e}</title>\n                <attr><key>Local:</key><value>${t[e].local.join(", ")||"--- None ---"}</value></attr>\n                <attr><key>External:</key><value>${t[e].external.join(", ")||"--- None ---"}</value></attr>\n            </item>`).join("")}\n    </list>\n    `;const command=()=>({name:"dependencies",aliases:["deps","dependents"],run:dependencies,template:template$2,args:packageFilters});var template$3=({configs:e})=>`\n    <bar>-</bar>\n    <h1>Packages to be Built</h1>\n    <bar>-</bar>\n    <list>\n        ${[].concat(...Object.values(e)).map(({post:{name:e,srcDir:t,destDir:n}={},type:r}={})=>`\n                    <item>\n                        <title>${e} (${r})</title>\n                        <details>${t} -> ${n}</details>\n                    </item>\n                `).join("")}\n    </list>\n    `;const removeDir=promisify(rimraf);var buildPackages=({plugins:e={}}={})=>({root:t,rootManifest:n,configs:r={}}={})=>removeDir(path.resolve(t,"dist")).then(()=>Promise.all([].concat(...Object.values(r)).map(r=>e[r.type].build({root:t,config:r}).then(()=>e[r.type].postBuild({root:t,rootManifest:n,config:r.post}))))),buildRollupConfigs=({plugins:e={}})=>({packageNames:t=[],rootManifest:n,dependencies:r,structures:s,manifests:a,types:i}={})=>t.map(t=>"unknown"!==i[t]?{[t]:e[i[t]].config({rootManifest:n,dependencies:r[t],structure:s[t],manifest:a[t]})||{}}:{[t]:{}}).reduce(collapse,{});const filter$2=({allPackages:e,changedAndPublishable:t,needsPublishing:n})=>e||t||n?{}:{onlyPublishable:!0},command$3=()=>({name:"build",run:build,template:template$3,effect:buildPackages,args:packageFilters});var template$4=({checks:e})=>`\n    <bar>-</bar>\n    <h1>Checked Packages</h1>\n    <bar>-</bar>\n    <list>\n        ${Object.entries(e.packages).map(([e,t])=>`<item>\n                <title>${e}</title>\n                ${Object.entries(t).filter(([e])=>"publishable"!==e).map(([e,t])=>t?`<check><success>${e}</success></check>`:`<check><fail>${e}</fail></check>`).join("")}\n                <check>${Array(Object.keys(t).reduce((e,t)=>e.length>t.length?e:t,0).length||3).join("─")}</check>\n                <check>${t.publishable?"<success>publishable</success>":"<fail>not publishable</fail>"}</check>\n            </item>`).join("")}\n    </list>\n    <bar>-</bar>\n    <title>Repository</title>\n    ${Object.entries(e.root).map(([e,t])=>t?`<check><success>${e}</success></check>`:`<check><fail>${e}</fail></check>`).join("")}\n    `;const command$4=()=>({name:"check",run:check,template:template$4,args:packageFilters}),registry=registryUrl(),setAuthToken=e=>new Promise((t,n)=>{process.chdir(e);const r=localOrHomeNpmrc();fs__default.existsSync(r)||n("For some reason no npmrc file exists.");const s=`${registry.replace("https:","").replace("http:","")}:_authToken=`,a=s+"${NPM_TOKEN}",i=fs__default.readFileSync(r,"utf-8").trim()+"\n";return-1!==i.indexOf(a)?(console.log("Just checked... .npmrc already has the token."),t()):-1!==i.indexOf(s)?(console.error("The .npmrc already has a token for this registry."),console.error(s),n(`Auth token for registry exists ${s}`)):(fs__default.writeFileSync(r,`${i}${a}\n`,"utf-8"),t())});var deployNpm=({root:e,publishing:t})=>setAuthToken(e).then(()=>Promise.all(t.map(t=>(process.chdir(path.resolve(e,"dist",t)),console.log(`Publishing [${t}]...`),execa("npm",["publish","--registry",registry,"--access","public"]).then(e=>console.log(e.stdout)).catch(console.log))))),template$5=({packageNames:e,destination:t,publishing:n})=>`\n    <bar>-</bar>\n    <h1>Publishable Packages</h1>\n    <bar>-</bar>\n    <list>\n        ${e.map(e=>`<item>\n                    <check>\n                        ${n.includes(e)?`<success>${e}</success>`:`<fail>${e}</fail>`}\n                        <attr><key>NPM:</key><value>${t[e].destVersion}</value></attr>\n                        <attr><key>Next:</key><value>${t[e].srcVersion}</value></attr>\n                    </check>\n                </item>`).join("")}\n    </list>\n`;const command$5=()=>({name:"publish",aliases:["deploy"],run:publish,template:template$5,effect:()=>e=>{var t=process.env;const n=t.NPM_TOKEN,r=t.GH_USER,s=t.GH_EMAIL,a=t.GH_REPO,i=t.GH_TOKEN;if(!n)throw new Error("The NPM_TOKEN env variable must be set!");if(!r)throw new Error("The GH_USER env variable must be set!");if(!s)throw new Error("The GH_EMAIL env variable must be set!");if(!a)throw new Error("The GH_REPO env variable must be set!");if(!i)throw new Error("The GH_TOKEN env variable must be set!");return deployNpm(e)}});var git$2=configureGit().outputHandler((e,t,n)=>{t.pipe(process.stdout),n.pipe(process.stderr)}),setupGit=()=>{var e=process.env;const t=e.GH_USER,n=e.GH_EMAIL,r=e.GH_REPO,s=e.GH_TOKEN;return console.log("Setting committer..."),git$2.addConfig("user.name",t).then(()=>git$2.addConfig("user.email",n)).then(()=>console.log("Setting up branch...")).then(()=>git$2.addRemote("origin-deploy",`https://${s}@github.com/${r}.git`)).then(()=>git$2.fetch("origin-deploy","master")).then(()=>git$2.checkout(["-B","deploy-master","--track","origin-deploy/master"])).then(()=>git$2.reset(["--hard","origin-deploy/master"]))},deployGit=()=>(console.log("Pushing to deploy remote..."),git$2.push(["origin-deploy","HEAD:master","--tags"]));const readJson=promisify(jsonFile.readFile),writeJson=promisify(jsonFile.writeFile),git$3=configureGit();var updatePackages=({root:e,updates:t,packageNames:n=[],structures:r={},latest:s})=>{const a=s.releaseNumber+1;return console.log(`Starting release #${a}`),console.log("Updating package.json files..."),Promise.all(n.filter(e=>e in t).map(n=>{const s=(r[n]||{}).srcDir,a=path.resolve(e,s,"package.json");return readJson(a).then(e=>_extends({},e,{version:t[n].new})).then(e=>writeJson(a,e,{spaces:4})).then(()=>({name:n,version:t[n].new,file:a}))})).then((()=>{var e=asyncToGenerator(function*(e){return console.log("Staging files for commit..."),yield git$3.add(map(e,"file")),e});return function(t){return e.apply(this,arguments)}})()).then((()=>{var e=asyncToGenerator(function*(e){return console.log("Committing updates..."),yield git$3.commit(`release(${a}): Update package versions for ${e.length>1?`${e.length} packages.`:"1 package."}\n        \n${e.map(function({name:e,version:t}){return`v${t} ${e}`}).join("\n")}\n\n[skip ci]\n`),e});return function(t){return e.apply(this,arguments)}})()).then(e=>(console.log("Tagging commit with package versions..."),Promise.all(e.map(({name:e,version:t})=>git$3.addTag(`${e}-v${t}`))))).then(()=>(console.log("Tagging commit with new latest release tag..."),git$3.addTag(`#${a}`)))},template$6=({updates:e})=>`\n    <bar>-</bar>\n    <h1>Packages to be updated</h1>\n    <bar>-</bar>\n    <list>\n        ${Object.entries(e).map(([e,{old:t,new:n,type:r,reason:s}])=>`\n                    <item>\n                        <title>${e} - ${r}</title>\n                        <check>${s}</check>\n                        <check>${t} -> ${n}</check>\n                    </item>\n                `).join("")}\n    </list>\n    `;const createPatch=({name:e,version:t,reason:n})=>({[e]:{type:"patch",old:t,new:semver.inc(t,"patch"),reason:n}});var recommendVersions=({packageNames:e=[],dependencies:t={},manifests:n={},changes:r=[]}={})=>e.length<=0?{}:e.map(e=>{const s=(n[e]||{}).version;if(s){if("0.0.0"===s)return{[e]:{type:"patch",old:s,new:"0.0.1",reason:"Prereleased"}};if(semver.lt(s,"0.1.0")){const n=filter(r,t=>!!t.scopes&&t.scopes.includes(e));if(n.length>0)return createPatch({name:e,version:s,reason:`This had ${1===n.length?"1 change":`${n.length} changes`} while in development.`});if(!t[e])return;const a=filter(r,n=>!!n.scopes&&intersect(t[e].local,n.scopes).length>0);if(a.length>0)return createPatch({name:e,version:s,reason:`There ${1===a.length?"was 1 change":`were ${a.length} changes`} in dependencies while in development.`})}else;}}).filter(e=>e).reduce(collapse,{});const CI$1=process.env.CI,command$6=()=>({name:"version",aliases:["update"],run:version,template:template$6,effect:()=>e=>{if(!CI$1)throw new Error("Committing new versions should only happen in CI.");return setupGit().then(()=>updatePackages(e)).then(()=>deployGit())}}),writeFile=promisify(fs__default.writeFile),writeJson$1=promisify(jsonFile.writeFile),fixers={"has readme file":({root:e,structure:{srcDir:t},contents:n})=>(console.log("Creating [readme.md]..."),writeFile(path.resolve(e,t,"readme.md"),n)),"has a version number":({root:e,structure:{srcDir:t},version:n})=>(console.log("Creating [package.json]..."),writeJson$1(path.resolve(e,t,"package.json"),{version:n},{spaces:4}))};var effect=()=>({root:e,structure:t,fixes:n})=>Promise.all(Object.entries(n).map(([n,r])=>fixers[n](_extends({root:e,structure:t},r))));const templates={"has readme file":"A readme will be created.","has a version number":"A version will be added."};var template$7=({name:e,fixes:t})=>`\n    <bar>-</bar>\n    <h1>Prereleasing [${e}]</h1>\n    <bar>-</bar>\n    <list>\n    ${Object.entries(t).map(([e])=>`<check><success>${templates[e]}</success></check>`).join("")}\n    </list>\n`;inquirer.registerPrompt("autocomplete",autocomplete);const searchPackages=e=>(t,n="")=>new Promise(t=>{setTimeout(()=>t(fuzzy.filter(n,e).map(e=>e.original||e)),500)});var pickPackage=({message:e="Which package should we pick?",packageNames:t})=>inquirer.prompt([{type:"autocomplete",name:"name",message:e,source:searchPackages(t)}]).then(({name:e})=>e),fixPackages=({plugins:e={}}={})=>({type:t,name:n,checks:r})=>{const s={fixable:[],fixes:{}};return t&&e[t]&&e[t].fix?e[t].fix({name:n,checks:r}):s};const command$7=()=>({name:"prerelease",run:prerelease,template:template$7,effect:effect}),paths=(e,t=[],n)=>t.reduce((t,r)=>_extends({},t,{[r]:path.resolve(n,e[r])}),{});var build$1=({root:e,config:t})=>rollup.rollup(_extends({},t.in,paths(t.in,["input"],e))).then(n=>Promise.all(t.out.map(t=>n.write(_extends({},t,paths(t,["file"],e),{exports:n.exports.length>1?"named":0===n.exports.length?"none":"default"===n.exports[0]?"default":"named"})))));const writeFile$1=promisify(fs__default.writeFile);var entyre=({readmePath:e="./readme.md",packageJsonPath:t="./package.json",config:n={},readme:r=""}={})=>({name:"entyre",transform(e,t){if(".md"!==path.extname(t))return{code:e};var s=parse$2({content:e});const a=s.body,i=s.code;var o=s.attributes;return r=a,n=void 0===o?{}:o,{code:i}},onwrite:()=>asyncToGenerator(function*(){return Promise.all([writeFile$1(t,JSON.stringify(n,null,4),"utf-8"),writeFile$1(e,r,"utf-8")])})()}),stripPartImports=(e=[])=>e.map(e=>{if(!e.startsWith("@")&&e.includes("/"))return e.split("/")[0];const t=(e.match(/\//g)||[]).length;if(e.startsWith("@")&&t>1){const t=e.split("/");return`${t[0]}/${t[1]}`}return e});const babelConfig={babelrc:!1,presets:[["env",{modules:!1,targets:{node:"6"}}],"stage-0"],plugins:["external-helpers"],exclude:["node_modules/**"]},input=({file:e,dependencies:t,structure:n,plugins:r})=>({input:path.resolve(n.root,n.srcDir,e),external:t.external,plugins:r}),output=({file:e,structure:t,format:n,banner:r})=>({file:path.resolve(t.root,t.destDir,e),format:n,banner:r}),postInfo=({structure:{name:e,srcDir:t,destDir:n},manifest:r,dependencies:{external:s},rootManifest:{dependencies:a}})=>({name:e,srcDir:t,destDir:n,packageConfig:r,dependencyVersions:pick(a,intersect(stripPartImports(s),Object.keys(a)))});var rollup$2=({type:e,file:t,outFile:n,dependencies:r,structure:s,manifest:a,rootManifest:i,format:o,banner:l,plugins:c})=>({type:e,in:input({file:t,dependencies:r,structure:s,plugins:c}),out:[output({structure:s,file:n||t,format:o,banner:l})],post:postInfo({structure:s,manifest:a,dependencies:r,rootManifest:i})});const commonPlugins=[markdown(),nodeResolve({extensions:[".js",".json",".md"],customResolveOptions:{moduleDirectory:["src/node_modules","node_modules"]}}),babel(babelConfig),uglify({},uglifyEs.minify),filesize()];var check$1=(()=>{var e=asyncToGenerator(function*({structure:{files:e=[]}={},manifest:{version:t}={}}={}){const n={"has a version number":!!t,"has index.md":e.includes("index.md")};return _extends({},n,{publishable:Object.values(n).every(function(e){return e})})});return function(){return e.apply(this,arguments)}})();const readFile$1=promisify(fs__default.readFile),type="entyre-package",rollupConfig={type:type,outFile:"index.js",format:"cjs"};var entyrePackage={type:type,filter:({srcDir:e=".",files:t=[]})=>{if(t.includes("package.json")){const t=require(path.resolve(e,"package.json"));return t.main&&".md"===path.extname(t.main)}return t.includes("index.md")},manifest:({root:e,structure:{srcDir:t}})=>readFile$1(path.resolve(e,t,"index.md"),"utf-8").then(frontMatter).then(({attributes:e})=>e),config:e=>[rollup$2(_extends({},rollupConfig,{file:e.manifest.main||"index.md",plugins:[entyre({readmePath:path.resolve(e.structure.destDir,"readme.md"),packageJsonPath:path.resolve(e.structure.destDir,"package.json")}),...commonPlugins]}))],build:build$1,postBuild:()=>{},check:check$1};const copy=promisify(fs__default.copyFile),writeJson$2=promisify(jsonFile.writeFile),requiredProps$1=["description","homepage","author","repository","bugs","license"];var postBuild=({root:e,rootManifest:t,config:n})=>Promise.all([copy(path.resolve(e,"LICENSE"),path.resolve(e,n.destDir,"LICENSE")),copy(path.resolve(e,n.srcDir,"readme.md"),path.resolve(e,n.destDir,"readme.md")),writeJson$2(path.resolve(e,n.destDir,"package.json"),_extends({name:n.name},n.packageConfig,pick(t,requiredProps$1),{dependencies:_extends({},n.packageConfig.dependencies,n.dependencyVersions)}),{spaces:4})]);const cache$2={};var getJsDetails=({root:e,name:t,structure:{srcDir:n}})=>{if(t in cache$2)return cache$2[t];const r=path.resolve(e,n,"package.json"),s=fileExists.sync(r)?require(r):{};return cache$2[t]=s,s},check$2=(()=>{var e=asyncToGenerator(function*({structure:{files:e=[]}={},manifest:{main:t,bin:n,version:r}={}}={}){const s=e.includes("index.js"),a=_extends({"has readme file":e.includes("readme.md"),"has a version number":!!r},s?{"has index":s}:{},t?{"has main":e.includes(t)}:{},n?{"has bin":Object.values(n).every(function(t){return e.includes(t)})}:{});return _extends({},a,{publishable:Object.values(a).every(function(e){return e})})});return function(){return e.apply(this,arguments)}})();const wait=e=>new Promise(t=>setTimeout(t,e));var getContents=({message:e="Create some contents: ",contents:t="",pause:n=2e3}={})=>(console.log(`${chalk.green("?")} ${chalk.white.bold(`${e}: `)} ${chalk.grey(`Opening your editor in ${n/1e3} secs...`)}`),wait(n).then(()=>({contents:editor.edit(t)})));const solvable=["has readme file","has a version number"],fixers$1={"has readme file":e=>getContents({message:`Write your readme.md for ${e}`,contents:`# ${e}`}),"has a version number":()=>Promise.resolve({version:"0.0.0"})};var fix=transmute__default().extend("fixable",({name:e,checks:t})=>Object.entries(t.packages[e]).filter(([e])=>solvable.includes(e)).filter(([,e])=>!e).map(([e])=>e)).extend("fixes",({name:e,fixable:t})=>Promise.all(t.map(t=>fixers$1[t](e).then(e=>({[t]:e})))).then(e=>e.reduce(collapse,{})));const banner="#!/usr/bin/env node",type$1="npm-cli-tool",plugins=[...commonPlugins,exec()],rollupConfig$1={type:type$1,plugins:plugins,banner:banner,format:"cjs"},packageJson=(e,t,n)=>!!n.includes("package.json")&&require(path.resolve(e,t,"package.json"));var npmCli={type:type$1,filter:({root:e=".",srcDir:t=".",files:n=[]})=>{const r=packageJson(e,t,n);return!!r&&(r.bin&&r.bin.constructor===Object)},manifest:getJsDetails,config:e=>Object.values(e.manifest.bin).map(t=>rollup$2(_extends({},rollupConfig$1,e,{file:t}))),build:build$1,postBuild:postBuild,check:check$2,fix:fix};const copy$1=promisify(fs__default.copyFile),type$2="vue-site",plugins$1=[vuePlugin({css:!0}),commonjs(),globals(),...commonPlugins],rollupConfig$2={type:type$2,plugins:plugins$1,file:"app.js",format:"iife"};var vueSite={type:type$2,filter:({files:e=[]})=>e.includes("index.html")&&e.includes("app.js"),manifest:getJsDetails,config:e=>[rollup$2(_extends({},rollupConfig$2,e,{format:"iife"}))],build:build$1,postBuild:({root:e,rootManifest:t,config:n})=>postBuild({root:e,rootManifest:t,config:n}).then(()=>copy$1(path.resolve(e,n.srcDir,"index.html"),path.resolve(e,n.destDir,"index.html")))};const type$3="npm-package",rollupConfig$3={type:type$3,plugins:commonPlugins,format:"cjs"};var npmPackage={type:type$3,filter:({root:e=".",srcDir:t=".",files:n=[]})=>{if(n.includes("package.json")){const r=require(path.resolve(e,t,"package.json"));return r.main?".js"===path.extname(r.main)||n.includes("index.js"):n.includes("index.js")}return n.includes("index.js")},manifest:getJsDetails,config:e=>rollup$2(_extends({},rollupConfig$3,e,{file:e.manifest.main||"index.js"})),build:build$1,postBuild:postBuild,check:check$2,fix:fix};const CI=process.env.CI,kli=configure({defaultStyle:CI?{}:style}),cli=kli({config:{plugins:[npmPackage,npmCli,vueSite,entyrePackage]},cleanse:{plugins:(e=[])=>keyBy(e,"type")},default:"list",commands:[command$3(),command$2(),command$4(),command(),command$1(),command$7(),command$5(),command$6()]});cli.execute(process.argv.slice(2));
